%ext ck4

#Load the modified graphics
%egahead EGAHEAD.CK4
%egadict EGADICT.CK4				#Use KG graphics

#New levels
%maphead MAPHEAD.CK4

#New tileinfo
%patchfile $249C2 CKxBM.tli

#Patch sounds
%patchfile $20DF0 AUDIOHED.CK4	#Audio header
%patchfile $354F6 AUDIODCT.CK4	#Audio dictionary

%patchfile $1FE47 CKxBM.bin			#New loading screen


###############
#STATUS WINDOW#
###############

#Center lives, remove drops
%patch $7FC2 $0080W
%patch $7FE5 $B8 $00AFW  $50 $9A $1D060DE3RL     $83 $C4 $0A $A1 $7A6AW  $99
             $52 $50 $B8 $0029W  $50 $B8 $0002W  $50 $B8 $0080W  $50 $B8 $00B0W
                 $50 $0E $E8 $FB67W $83 $C4 $0C $EB $48

#Don't display any Wetsuit stuff
%patch $8058 $EB $4D

#Convert Rescued counter into Wetsuit counter
%patch $7E20 $005FW #Vertical text
%patch $7E26 $0045W #Horizontal
%patch $7E42 $000CW #Rect Width
%patch $7E4A $0087W #Horizontal position
%patch $2F49C "ITEM   " $00
%patch $7E7C $7A5CW #Count suit
%patch $7E6A $0088W #Horizontal position

#Move press
%patch $80BE $0078W #Horizontal position
%patch $80DC $0078W #Horizontal position


########
#LEVELS#
########

#Keen can use "can't swim" blocks in levels
%patch $D257 $2A06W #Top water: nothing (At $D21E)
%patch $D259 $2A06W #Right water: nothing (At $D21E)
%patch $D25B $2A06W #Bottom water: nothing (At $D21E)
%patch $D25D $2A06W #Left water: nothing (At $D21E)
%patch $E20C $37

#Stop the stun stars appearing
%patch $B739  $5F $5E $8B $E5 $5D $CB

#Keen starts game from another level
%patch $5CBB $7A68W $000CW

#Winning level goes to next level
%patch $6B1E $FF $06 $7A20W  $90 $90 $90
%patch $6B31 $A1 $7A20W  $A3 $7A68W
%patch $6B3D $EB $0A

#Auto restart level, decrements lives (Frees $5CD3-$5D12)
%patch $668C $9A $146008A8RL    $5F $5E $8B $E5 $5D $CB

#Demo recording cheat text
%patch $2F10E "  Record a demo from level(1-13):" $00

#Number of levels demo can be recorded from:
%patch $6516 $0D

#Warp cheat text
%patch $2F418 " Warp to which level(1-13):" $00

#Levels F10 + W accesses
%patch $77E4 $0D

#Level high scores are entered in
%patch $5BC0 $000DW

#Number of high scores
%patch $5AB7 $06
%patch $5BAA $06

#Position of names and scores
%patch $5A16 $0043W #Vertical location of table

#Wetsuit text
%patch $30A4B  "Nice! Now let's go  " $0A
               "to Mr. Logan!   " $00

#No wetsuit text
%patch $30A3D  "Not yet!     " $00

#Lindsey's window
%patch $30999 "The Oracle told that  " $0A
              "leftover mutants have" $0A
              "attacked Metro City." $0A
              "      " $00

#Keen's reply window
%patch $309FA "I will destroy" $0A
              " them once and  " $0A
              "for all! " $00

#Level 1
%patch $1F050 " Councilsville" $00
%patch $1F210 "Keen passes across  " $0A "Councilsville     " $00

#Level 2
%patch $1F060 "Rock Hideout" $00
%patch $1F240 " Keen finds the" $0A "Rock Hideout" $00

#Level 3
%patch $1F070 " Crystal Chamber" $00
%patch $1F260 "Keen gleams for   " $0A "the Crystal Chamber " $00

#Level 4
%patch $1F090 "   Pyramid of Mirage   " $00
%patch $1F290 "Keen disappears and " $0A "appears inside " $0A "the Pyramid of Mirage" $00

#Level 5
%patch $1F0B0 " BWB Megarocket" $00
%patch $1F2D0 "Keen hops in the  " $0A "BWB Megarocket " $00

#Level 6
%patch $1F0C0 " Car Park" $00
%patch $1F300 "Keen swiftly parks" $0A "  in the Car Park " $00

#Level 7
%patch $1F0D0 "Far Woods" $00
%patch $1F330 "  Keen visits the " $0A "Far Woods" $00

#Level 8
%patch $1F0E0 "High Flat" $00
%patch $1F350 "Keen has acrophobia " $0A "at the High Flat    " $00

#Level 9
%patch $1F0F0 "Sewers " $00
%patch $1F380 "Keen gets wet in the" $0A "Sewers " $00

#Level 10
%patch $1F100 "Office Building" $00
%patch $1F3A0 "Keen climbs the " $0A "Office Building" $00

#Level 11
%patch $1F110 "  Dr. Mangle's Lab  " $00
%patch $1F3D0 "Keen rushes into   " $0A "Dr. Mangle's Lab    " $00

#Level 12
%patch $1F130 "     Slug Pit     " $00
%patch $1F400 "Keen mysteriously    " $0A "lurks in the Slug Pit    " $00

#Level 13
%patch $1F150 " High Scores  "                  $00
%patch $1F430 "Keen oddly gets to" $0A " the High Scores  " $00


#######
#MUSIC#
#######

%patch $8CCD $96 $03 #$2F206

#Change number of songs:
#%patch $8CEF $9B $00
#%patch $8C75 $C891W
#%patch $8C83 $C891W
#%patch $8D83 $C891W

%patch $8CA4 $1A #Number of level song entries (24)

%patch $2F206 $0A $00 #Unused level 0 (for level music place holder)
              $07 $00 #Councilsville 1
              $06 $00 #Rock Hideout 2
              $09 $00 #Crystal Chamber 3
              $07 $00 #Pyramid of Mirage 4
              $08 $00 #BWB Megarocket 5
              $01 $00 #Car Park 6
              $03 $00 #Far Woods 7
              $04 $00 #High Flat 8
              $04 $00 #Sewer 9
              $03 $00 #Office Building 10
              $00 $00 #Dr. Mangle's Lab 11
              $08 $00 #Slug Pit 12
              $05 $00 #High Scores 13
	      $02 $00 #Unused level 14 (for level music place holder)
	      $08 $00 #Unused level 15 (for level music place holder)

#Add new music
#Index of first music chunk within audio chunks:
%patch $8CEF $0097W # 98 is hex for 152- the number of the first song in my list.txt. originally $009CW

#Start address of music chunks
#reduce start address by 2x that of "First Audio Entry"
%patch $8C75 $C88BW # clear_music()- originally C895W
%patch $8C83 $C88BW # clear_music()
%patch $8D83 $C88BW # StartMusic()
%patch $8C91 11      # Total Number of Songs

#Other music played: (Values here is number of LEVELS whose music is used)
%patch $9CD7 $000FW #Ending Sequence (Slug Village)
%patch $F4CA $000EW #Talking to Ancient (Ancient)

#Change music when Lindsey spoken to
%patch $EFDD $06BD20C7RL
%patch $EFD9 $0000W      #Play this level's song


####################
#SPRITE: GUN MUTANT#
####################

#Sprite doesn't float
%patch $125D1 $55 $8B $EC $56 $8B $76 $06 $8B $1E $D6 $A7 $8B $47 $24 $3B $44
              $28 $73 $21 $8B $47 $28 $3B $44 $24 $76 $19 $8B $47 $0A $3B $44
              $0A $73 $07 $C7 $44 $0E $FFFFW  $EB $05 $C7 $44 $0E $0001W  $C7 #Face Keen to shoot at him
              $44 $1C $37BEW  $5E $5D $CB                                     #Change action to shoot

#Sprite's shots have 3 frames
%patch $126A6 $3836W
%patch $326FE $3836W

#Sprite uses new collision
%patch $32624 $2EE70146RL
%patch $32642 $2EE70146RL
%patch $32660 $2EE70146RL
%patch $3267E $2EE70146RL

#Stunned sprite action (1st frame of old bullet)
%patch $32688 $01B4W $01B4W $0002W $0000W $0000W $00F0W $0000W $0000W
              $09DC16C9RL   $00000000L    $09DC176ERL   $3818W

#New Sprite collision, react to Keen's shot, kill Keen
%patch $2EFB6 $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $02 $75 $09
              $9A $0B8013E9RL     $5F $5E $5D $CB $83 $3D $03 $75 $18 $C7 $44
              $16 $0000W  $C7 $44 $06 $0008W  $B8 $3818W  $50 $57 $56 $9A $09DC1695RL
                          $83 $C4 $06 $5F $5E $5D $CB

#Shooting sprite
%patch $32668 $37FAW #Sprite shooting 2
%patch $32686 $37BEW #Sprite float

#Float - keep floating
%patch $3262C $37BEW #Sprite float


#########################
#BOUNDER: BIONICLE ROBOT#
#########################

#Bounders chase Keen
%patch $111C2 $90 $90

#Allow 5-frames
%patch $11205 $E9 $0081W

#Jumps are 5-frame
%patch $31DBE $01EFW $01EFW $0003W $0000W $0000W $0014W $0000W $0000W
                     $09DC16C9RL   $10800938RL   $1080097ERL   $2F6CW
%patch $31DDC $01F0W $01F0W $0003W $0000W $0000W $0014W $0000W $0000W
                     $09DC16C9RL   $10800938RL   $1080097ERL   $2F12W
%patch $31D82 $01EBW $01EBW $0003W $0000W $0000W $0014W $0000W $0000W
                     $09DC16C9RL   $10800938RL   $1080097ERL   $2F30W
%patch $31DA0 $01ECW $01ECW $0003W $0000W $0000W $0014W $0000W $0000W
                     $09DC16C9RL   $10800938RL   $1080097ERL   $271AW
%patch $3158A $01EDW $01EDW $0003W $0000W $0000W $0014W $0000W $0000W
                     $09DC16C9RL   $10800938RL   $1080097ERL   $2F4EW 

#Bounder collision: Lethal, shootable
%patch $11138 $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $02 $75 $09     #Check for Keen (Type 2)
              $9A $0B8013E9RL     $5F $5E $5D $CB $83 $3D $03 $75 $0E $B8         #If Keen, kill him; check for shot (Type 3)
              $2F8AW  $50 $57 $56 $9A $09DC1695RL     $83 $C4 $06 $5F $5E $5D $CB #If shot, become $2F8AW

#Jump height
%patch $111BC $FFB5W

#Shot Bounder doesn't jump
%patch $11176 $5F $5E $5D $CB

#Bounder can't be ridden
%patch $110FE $21


#########################
#BERKELOID: SLIME MUTANT#
#########################

#Berkeloid walks instead of floating
%patch $10DB5 $55 $8B $EC $56 $8B $76 $06 $FF $74 $20 $33 $C0 $50 $FF $74 $1E
              $FF $74 $0C $FF $74 $0A $8B $C6 $05 $46 $00 $50 $9A $16541641RL
              $83 $C4 $0C $5E $5D $CB

#Berkeloids flame quickly
%patch $31A0E $108004A4RL
%patch $31A1A $2AF8W
%patch $31A08 $0016W

#Modify collision code to be stunnable
%patch $10D30 $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $02 $75 $07
              $9A $0B8013E9RL     $EB $13 $83 $3D $03 $75 $0E $B8 $2BACW  $50
              $57 $56 $9A $09DC1695RL     $83 $C4 $06 $5F $5E $5D $CB

#Stunned Berkeloid action =$2BACW
%patch $31A1C $0205W $0205W $0002W $0000W $0000W $0000W $0000W $0000W
              $09DC16C9RL   $00000000L    $09DC1913RL   $0000W

#Berkeloid flames vanish on hitting the ground:
%patch $10D89 $0000W

#Moving speed
%patch $31974 $0002 $0000W #Speed 1
%patch $31992 $0002 $0000W #Speed 2
%patch $319B0 $0002 $0000W #Speed 3
%patch $319CE $0002 $0000W #Speed 4


############################
#ORACLE MEMBER: SNAKE LOGAN#
############################

#Require only 1 member to be rescued.
%patch $6AE6 $01 $7D

#Member move has 1 frame
%patch $30E28 $0168W $0168W $0000W $0000W $0000W $000AW $0000W $0000W
              $00000000L    $09DC1795RL   $09DC1795RL   $1FB8W

#Don't show Members saved in High Scores
%patch $5A36 $25

#Council member text
%patch $30C17 "Ah, you have found a" $0A
              "computer chip!  " $0A
              "We can now leave. " $0A
              "Thank you so  " $0A
              "much, Keen!" $00

#Keen's reply:
%patch $30A71 "You're very welcome, " $0A
              "Mr. Logan!" $00

%patch $30B6B "Your very welcome," $0A
              "Mr. Logan!        " $0A
              "               " $0A
              "               " $00


########################
#WORMOUTH: LITTLE SLIME#
########################

#Wormouth has a two frame chasing animation
%patch $3154E $01CCW $01CAW $0003W $0001W $0001W $0014W $0080W $0000W
              $108000D4RL   $1080017CRL   $09DC1795RL   $26FCW
%patch $3156C $01CDW $01CBW $0003W $0001W $0001W $0014W $0080W $0000W
              $108000D4RL   $1080017CRL   $09DC1795RL   $26DEW

#Wormouth doesn't look for Keen
%patch $108F4 $EB $1F


#############################
#MIMROCK: PURPLE MUTANT SLUG#
#############################

#Mimrocks always pursue Keen
%patch $11EA6 $3458W  #Mimrocks spawned chasing Keen
%patch $322C6 $3458W  #If waiting, chase
%patch $3237A $3458W  #Mimrock doesn't slam back down, once activated.
%patch $11EEB $EB $04 #Ditch the first "Is Keen facing the Mimrock?" check
%patch $11F05 $EB $04 #Ditch the second "Is Keen facing the Mimrock?" check
%patch $11F3B $EB $06 #Don't make the Mimrock slam down if he spies Keen

#After bouncing, run:
%patch $322AA $0189W $0185W
%patch $12068 $3458W


#########################
#FOOT: BIO MENACE GOPLAT#
#########################

#Foot is a platform
%patch $31D74 $10800D44RL #Moving airboard behavior
%patch $10F49 $10 $0001W  #Start moving down
%patch $31D78 $00000000L  #Foot collision
%patch $10F40 $14     #Keen can stand on


##############
#STORY SCREEN#
##############

#Disable star wars story screen
%patch $3CBD $04D1W


######
#KEEN#
######

#Keen can moon as often as he wants
%patch $BC29 $EB $04

#Mooning sequence
%patch $2F914 $003AW        #Mooning time


#########
#WETSUIT#
#########

#Change type to avoid trigger
%patch $12A05 $01

#Wetsuit got action =$2756W
%patch $315C6 $0206W $0206W $00001W $0000W $0000W $0048W $0000W $0008W
              $00000000L    $00000000L     $09DC176ERL   $0000W

#New Wetsuit collision: On Keentact vanish
%patch $12A30 $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $02 $75 $26
              $C7 $06 $7A5CW  $0001W  $9A $0E8F0AE2RL     $9A $16540D59RL
              $B8 $0013W  $50 $9A $187409F1RL     $83 $C4 $02 $C7
              $44 $1C $2756W  $C7 $44 $10 $FFFFW  $5F $5E $5D $CB

#Change cache to include Berkeloid
%patch $ECE9 $FD1EW


########
#SOUNDS#
########

#Don't play council member rescuing sound
%patch $6ABF $EB $0A

#Don't play level finishing sound
%patch $6B25 $EB $0A

#Don't play Keen enters and exits doors sound
%patch $BA53 $EB $0A

#Don't play Keen meets a Council Member sound
%patch $CDAB $EB $0A

#Don't play Keen can't swim sound
%patch $E20D $EB $0A

%end